package com.smppw.analysis.client;

import com.smppw.analysis.application.dto.performance.*;
import com.smppw.analysis.application.service.performance.FundPerformanceService;
import com.smppw.analysis.domain.dto.performance.WinVO;
import com.smppw.common.pojo.ResultVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * @author wangzaijun
 * @date 2023/8/7 15:52
 * @description 业绩表现api
 */
@RestController
@RequestMapping("/v1/api/performance")
public class FundPerformanceApi {
    private final FundPerformanceService service;

    public FundPerformanceApi(FundPerformanceService service) {
        this.service = service;
    }

    @PostMapping("indicator")
    public Map<String, Object> indicator(@RequestBody IndicatorReq req) {
        return this.service.calcIndicator(req);
    }

    @PostMapping("trend")
    public ResultVo<Map<String, Object>> trend(@RequestBody TrendReq req) {
        Map<String, Object> data = this.service.trend(req);
        return ResultVo.ok(data);
    }

//    @PostMapping("imf-trend")
//    public ResultVo<Map<String, Object>> imfTrend(@RequestBody ImfTrendReq req) {
//        Map<String, Object> data = this.service.imfTrend(req);
//        return ResultVo.ok(data);
//    }

    @PostMapping("dynamic-down")
    public ResultVo<Map<String, Object>> dynamicDown(@RequestBody DrawdownTrendReq req) {
        Map<String, Object> data = this.service.dynamicDown(req);
        return ResultVo.ok(data);
    }

    @PostMapping("correlation")
    public ResultVo<Map<String, Object>> cor(@RequestBody CorrelationReq req) {
        Map<String, Object> data = this.service.cor(req);
        return ResultVo.ok(data);
    }

    @PostMapping("win")
    public ResultVo<WinVO> win(@RequestBody WinReq req) {
        WinVO data = this.service.win(req);
        return ResultVo.ok(data);
    }

    @PostMapping("revenue")
    public ResultVo<Map<String, Object>> revenue(@RequestBody RevenueReq req) {
        Map<String, Object> data = this.service.revenue(req);
        return ResultVo.ok(data);
    }

    @PostMapping("interval")
    public ResultVo<Map<String, Object>> interval(@RequestBody IntervalReq req) {
        Map<String, Object> data = this.service.interval(req);
        return ResultVo.ok(data);
    }

    @PostMapping("rolling")
    public ResultVo<Map<String, Object>> rolling(@RequestBody RollingReq req) {
        Map<String, Object> data = this.service.rolling(req);
        return ResultVo.ok(data);
    }
}
