package com.smppw.analysis.domain.dao.info;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.ListUtil;
import com.smppw.analysis.domain.dataobject.info.BaseInfoDO;

import java.util.List;

public abstract class AbstractInfoDao<R extends BaseInfoDO> implements InfoDao<R> {
    @Override
    public List<R> listMultiInfo(List<String> secIds) {
        List<R> resultList = ListUtil.list(false);
        if (CollUtil.isEmpty(secIds)) {
            return ListUtil.empty();
        }
        List<List<String>> partition = ListUtil.partition(secIds, 200);
        for (List<String> fundIds : partition) {
            resultList.addAll(this.listMultiFundInfo(fundIds));
        }
        return resultList;
    }

    protected abstract List<R> listMultiFundInfo(List<String> subFundIds);
}
