package com.smppw.analysis.domain.dao.info;

import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.map.MapUtil;
import com.smppw.analysis.domain.dataobject.info.BaseInfoDO;
import com.smppw.constants.SecType;
import org.springframework.stereotype.Component;

import java.util.Map;

@Component
public class InfoFactory {
    private static final InfoDao<? extends BaseInfoDO> DEFAULT = (InfoDao<BaseInfoDO>) secIds -> ListUtil.empty();
    private static final Map<String, InfoDao<? extends BaseInfoDO>> INFO_DAP_MAP = MapUtil.newHashMap(8);

    private static final Map<String, String> SEC_INFO_KEY_MAP = MapUtil.newHashMap(8);

    static {
        SEC_INFO_KEY_MAP.put(SecType.PRIVATE_FUND, InfoConstants.PRIVATE_FUND_INFO);
        SEC_INFO_KEY_MAP.put(SecType.PUBLICLY_OFFERED_FUNDS, InfoConstants.FUND_INFO);
        SEC_INFO_KEY_MAP.put(SecType.PRIVATELY_OFFERED_FUND, InfoConstants.FUND_INFO);
    }

    public InfoFactory(Map<String, InfoDao<? extends BaseInfoDO>> component) {
        INFO_DAP_MAP.putAll(component);
    }

    @SuppressWarnings("unchecked")
    public <R extends BaseInfoDO> InfoDao<R> getInstance(String secType) {
        return (InfoDao<R>) INFO_DAP_MAP.getOrDefault(SEC_INFO_KEY_MAP.get(secType), DEFAULT);
    }
}
