package com.smppw.analysis.domain.dataobject.info;

import com.smppw.common.pojo.enums.Frequency;

/**
 * @author wangzaijun
 * @date 2023/8/11 14:52
 * @description 基本信息数据库实体
 */
public abstract class BaseInfoDO {
    /**
     * 标的id
     *
     * @return 标的id（基金、公司、经理、指数、组合、因子等id）
     */
    public abstract String getRefId();

    /**
     * 标的名称
     *
     * @return /
     */
    public abstract String getRefName();

    /**
     * 备案编码
     *
     * @return /
     */
    public abstract String getRegisterNumber();

    /**
     * 成立日期
     *
     * @return /
     */
    public abstract String getInceptionDate();

    /**
     * 净值频率
     *
     * @return 基金净值频率
     */
    public abstract Frequency getFrequency();
}
