package com.smppw.analysis.domain.dataobject.info;

import com.smppw.common.pojo.enums.Frequency;
import lombok.Getter;
import lombok.Setter;

@Setter
@Getter
public class PrivateFundInfoDO extends BaseInfoDO {
    /**
     * 基金id
     */
    private String fundId;
    /**
     * 基金全称
     */
    private String fundName;
    /**
     * 基金简称
     */
    private String fundShortName;
    /**
     * 备案编码
     */
    private String registerNumber;
    /**
     * 基金成立日
     */
    private String inceptionDate;

    /**
     * 净值频率
     */
    private String navFrequency;

    @Override
    public String getRefId() {
        return fundId;
    }

    @Override
    public String getRefName() {
        return fundName;
    }

    @Override
    public String getRegisterNumber() {
        return this.registerNumber;
    }

    @Override
    public String getInceptionDate() {
        return this.inceptionDate;
    }

    @Override
    public Frequency getFrequency() {
        if ("日".equals(this.navFrequency) || "天".equals(this.navFrequency)) {
            return Frequency.Daily;
        } else if ("周".equals(this.navFrequency)) {
            return Frequency.Weekly;
        } else if ("月".equals(this.navFrequency)) {
            return Frequency.Monthly;
        }
        return Frequency.Daily;
    }
}
