package com.smppw.analysis.domain.dataobject.nav;

import cn.hutool.core.date.DateUtil;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

@Setter
@Getter
public class CmNavDo extends BaseNavDO {
    /**
     * id
     */
    private Integer id;

    /**
     * 基金id，'CF'开头(后加36进制编码格式,不足8位长度左补零） 例：CF00000001
     */
    private String fundId;

    /**
     * 净值日期
     */
    private Date priceDate;

    /**
     * 单位净值
     */
    private BigDecimal nav;

    /**
     * 考虑分红再投资的单位累计净值
     */
    private BigDecimal cumulativeNav;

    /**
     * 分红不投资的单位累计净值
     */
    private BigDecimal cumulativeNavWithdrawal;

    /**
     * 创建者Id,默认第一次创建者名称，创建后不变更
     */
    private Integer creatorId;

    /**
     * 创建时间,默认第一次创建的getdate()时间
     */
    private Date createTime;

    /**
     * 修改者Id;第一次创建时与Creator值相同，修改时与修改人值相同
     */
    private Integer updaterId;

    /**
     * 修改时间;第一次创建时与CreatTime值相同，修改时与修改时间相同
     */
    private Date updateTime;

    /**
     * 记录的有效性；1-有效；0-无效；
     */
    private Integer isValid;

    @Override
    public String getRefId() {
        return this.fundId;
    }

    @Override
    public String getNavDate() {
        return DateUtil.formatDate(this.priceDate);
    }

    @Override
    public BigDecimal getNav() {
        return this.nav;
    }

    @Override
    public BigDecimal getCumulativeNav() {
        return this.cumulativeNav;
    }

    @Override
    public BigDecimal getCumulativeNavWithdrawal() {
        return this.cumulativeNavWithdrawal;
    }
}
