package com.smppw.analysis.domain.service.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.collection.ListUtil;
import cn.hutool.core.map.MapUtil;
import com.smppw.analysis.domain.dao.FundInformationDao;
import com.smppw.analysis.domain.dataobject.PrivatelyFundBaseInfoDo;
import com.smppw.analysis.domain.dataobject.PubliclyFundBaseInfoDo;
import com.smppw.analysis.domain.service.BaseInfoService;
import com.smppw.utils.StrategyHandleUtils;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.function.Function;

@Service
public class BaseInfoServiceImpl implements BaseInfoService {
//    private final CacheGateway<Object> cacheGateway;
//    private final IndexesProfileDao indexesProfileDao;
    private final FundInformationDao fundInformationDao;
//    private final CommonIndexMapper commonIndexMapper;
//    private ApplicationContext applicationContext;

    public BaseInfoServiceImpl(FundInformationDao fundInformationDao) {
//        this.cacheGateway = cacheFactory.getCacheGateway(property.getCacheType());
//        this.indexesProfileDao = indexesProfileDao;
        this.fundInformationDao = fundInformationDao;
//        this.commonIndexMapper = commonIndexMapper;
    }
//
//    @Override
//    public void setApplicationContext(@NonNull ApplicationContext applicationContext) throws BeansException {
//        this.applicationContext = applicationContext;
//    }

//    @Override
//    public List<ValueLabelVO> getCommonIndexList() {
//        List<CommonIndexDO> dataList = this.commonIndexMapper.selectList();
//        return dataList.stream().map(e -> new ValueLabelVO(e.getIndexId(), e.getIndexName())).collect(Collectors.toList());
//    }

//    @Override
//    public Frequency getNavFrequency(String secId) {
//        Frequency frequency;
//        String fundType = SecType.getSecType(secId, null);
//        if (SecType.MANAGER.equals(fundType) || SecType.COMPANY.equals(fundType)) {
//            frequency = Frequency.Monthly;
//        } else if (SecType.PRIVATELY_OFFERED_FUND.equals(fundType) ||
//                SecType.PUBLICLY_OFFERED_FUNDS.equals(fundType) ||
//                SecType.INDEX_FUND.equals(fundType) ||
//                SecType.RONGZHI_INDEX.equals(fundType)) {
//            String freq = this.fundInformationDao.getNavFrequencyByFundId(secId);
//            if ("天".equals(freq)) {
//                frequency = Frequency.Daily;
//            } else if ("周".equals(freq)) {
//                frequency = Frequency.Weekly;
//            } else {
//                frequency = Frequency.Monthly;
//            }
//        } else {
//            frequency = Frequency.Daily;
//        }
//        return frequency;
//    }

//    @Override
//    public Map<String, String> querySecName(List<String> allSecIdList) {
//        if (CollUtil.isEmpty(allSecIdList)) {
//            return MapUtil.empty();
//        }
//        int size = allSecIdList.size();
//        String key = RedisConst.SEC_NAME;
//        Map<String, Object> hget = this.cacheGateway.hget(key);
//        if (MapUtil.isEmpty(hget)) {
//            hget = MapUtil.empty();
//        }
//        Map<Boolean, List<String>> redisSecMap = allSecIdList.stream().collect(Collectors.groupingBy(hget::containsKey));
//        List<String> redisSecIds = redisSecMap.getOrDefault(Boolean.TRUE, ListUtil.empty());
//        List<String> noRedisSecIds = redisSecMap.getOrDefault(Boolean.FALSE, ListUtil.empty());
//        Map<String, Object> secNameMap = MapUtil.newHashMap(size, false);
//        if (CollUtil.isNotEmpty(noRedisSecIds)) {
//            Map<String, List<String>> typeSecMap = SecType.getTypeSecMap(noRedisSecIds, null);
//            // 市场基金
//            List<String> marketFundIds = ListUtil.of(SecType.PRIVATELY_OFFERED_FUND, SecType.PUBLICLY_OFFERED_FUNDS);
//            this.loadNameMap(secNameMap, typeSecMap, marketFundIds, this.fundInformationDao::getMarketFundIdNameMap);
//            // 市场指数
//            List<String> marketIndexIds = ListUtil.of(SecType.INDEX_FUND, SecType.RONGZHI_INDEX, SecType.THIRD_INDEX_FUND);
//            this.loadNameMap(secNameMap, typeSecMap, marketIndexIds, this.indexesProfileDao::getFundIdNameMap);
////            // 基金经理
////            List<String> managerIds = ListUtil.of(SecType.MANAGER);
////            this.loadNameMap(secNameMap, typeSecMap, managerIds, this.personnelInformationDao::getFundIdNameMap);
////            // 基金管理人
////            List<String> companyIds = ListUtil.of(SecType.COMPANY);
////            this.loadNameMap(secNameMap, typeSecMap, companyIds, this.companyInformationDao::getFundIdNameMap);
//            // 策略
//            List<String> strategyIds = ListUtil.of(SecType.STRATEGY);
//            this.loadNameMap(secNameMap, typeSecMap, strategyIds, this::getStrategyIdNameMap);
//            // 推送事件，存缓存
//            SaveCacheEvent<Map<String, Object>> event = new SaveCacheEvent<>(key, secNameMap, t -> {
//                this.cacheGateway.hset(key, t);
//                return this.cacheGateway.expire(key, 1, TimeUnit.DAYS);
//            });
//            this.applicationContext.publishEvent(event);
//        }
//        // 解决乱序问题
//        Map<String, String> result = MapUtil.newHashMap(size, true);
//        for (String secId : allSecIdList) {
//            String name = redisSecIds.contains(secId) ? MapUtil.getStr(hget, secId) : MapUtil.getStr(secNameMap, secId);
//            result.put(secId, name);
//        }
//        return result;
//    }

//    @Override
//    public List<MonetaryFundProfitDO> queryMonetaryFund(String fundId) {
//        return this.fundInformationDao.queryMonetaryFund(fundId);
//    }

    @Override
    public PrivatelyFundBaseInfoDo listPrivatelyFundInfo(String fundId) {
        return fundInformationDao.listPrivatelyFundInfo(fundId);
    }

    @Override
    public PubliclyFundBaseInfoDo listPublicFundInfo(String fundId) {
        return fundInformationDao.listPubliclyFundInfo(fundId);
    }

    /**
     * 把指定类型的标的的名称映射查询出来
     *
     * @param secNameMap 保存的map
     * @param typeSecMap 指定类型对应的标的
     * @param types      指定类型列表
     * @param function   查询操作封装
     */
    private void loadNameMap(Map<String, Object> secNameMap, Map<String, List<String>> typeSecMap,
                             List<String> types, Function<List<String>, Map<String, String>> function) {
        List<String> refIds = ListUtil.list(true);
        for (String type : types) {
            CollUtil.addAllIfNotContains(refIds, typeSecMap.getOrDefault(type, ListUtil.empty()));
        }
        if (CollUtil.isNotEmpty(refIds)) {
            secNameMap.putAll(function.apply(refIds));
        }
    }

    private Map<String, String> getStrategyIdNameMap(List<String> strategyIds) {
        if (CollUtil.isEmpty(strategyIds)) {
            return MapUtil.empty();
        }
        Map<String, String> result = MapUtil.newHashMap(strategyIds.size(), true);
        for (String strategyId : strategyIds) {
            result.put(strategyId, StrategyHandleUtils.getStrategy(strategyId).getStrategyNameDesc());
        }
        return result;
    }
}
